#ifndef _FRAME_LIST_H_
#define _FRAME_LIST_H_

#include "xste.h"


struct frame
	{
	char *name;		/* this is the frame number in ASCII decimal */
	char *text;
	int end_frame;
	int status;
	int browser_line;	

	int pattern;
	int background;
	int emphasis1;
	int emphasis2;

	int pattern_contrast;
	int background_contrast;
	int emphasis1_contrast;
	int emphasis2_contrast;

	char *fontname;
	int symbols;
	int fontsize;
	int iso_extension;
	double outline_thickness;
	double blur_radius;   
	font_desc_t *pfd;

	int espace;
	int vespace;

	/* not saved */
	unsigned long start_sample;
	unsigned long end_sample;
	time_t last_updated_time;

	int width;
	int height;
	int xpos;
	int ypos;


	struct frame *nxtentr;
	struct frame *prventr;
	};
struct frame *frametab[2]; /* first element points to first entry,
			second element to last entry */


#endif /* _FRAME_LIST_H_ */

