#ifndef _TEMP_FRAME_H_
#define _TEMP_FRAME_H_

struct temp_frame
	{
	char *name;/* this is the frame */

	char *text;
	int end_frame;
	unsigned long start_sample;
	unsigned long end_sample;
	unsigned long picture_number;
	int status;
	int browser_line;	
	time_t last_updated_time;

	int pattern;
	int background;
	int emphasis1;
	int emphasis2;

	int pattern_contrast;
	int background_contrast;
	int emphasis1_contrast;
	int emphasis2_contrast;

	char *fontname;
	int symbols;
	int fontsize;
	int iso_extension;
	double outline_thickness;
	double blur_radius;   
	font_desc_t *pfd;

	int espace;
	int vespace;

	struct temp_frame *nxtentr;
	struct temp_frame *prventr;
	};
struct temp_frame *temp_frametab[2]; /* first element points to first entry,
			second element to last entry */


#endif /* _TEMP_FRAME_H_ */
