/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


FD_xste *create_form_main_form(void)
{
FL_OBJECT *obj;

fdui = (FD_xste *) fl_calloc(1, sizeof(*fdui));

fl_set_idle_callback(idle_cb, 0);

fdui -> animation_template_form =\
fl_bgn_form(FL_UP_BOX, 700, 500);

fdui -> animation_template_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 5, 350, 30,\
	"A N I M A T I O N  T E M P L A T E");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

// entity browser
fdui -> animation_template_form_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 20, 50, 100, 200, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, animation_template_form_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, animation_template_form_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);

// entity input
fdui -> animation_template_form_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 260, 100, 30, "Entity name");
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, animation_template_form_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);

// entity delete	
fdui -> animation_template_form_delete_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 130, 190, 90, 30, "DELETE");
	fl_set_object_callback(obj, animation_template_form_delete_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

// entity add
fdui -> animation_template_form_add_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 130, 260, 90, 30, "ADD");
	fl_set_object_callback(obj, animation_template_form_add_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

// fontname
fdui -> animation_template_form_fontname_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 130, 50, 90, 30, "FONTNAME");
	fl_set_object_callback(obj, animation_template_form_fontname_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> animation_template_form_fontname_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 230, 50, 245, 25, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

// fontsize
fdui -> animation_template_form_character_point_size_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 485, 50, 35, 30, "size");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_character_point_size_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);
	fl_set_input(obj, "-1");

// font ISO
fdui -> animation_template_form_character_style_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 530, 50, 30, 30, "ISO");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_character_style_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);
	fl_set_input(obj, "-1");

// font outline
fdui -> animation_template_form_outline_thickness_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 570, 50, 50, 30, "outline");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		animation_template_form_outline_thickness_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);
	
// font blur
fdui -> animation_template_form_blur_radius_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 630, 50, 50, 30, "blur");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, animation_template_form_blur_radius_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);

// positioner
fdui -> animation_template_form_x_y_positioner = obj =\
	fl_add_positioner(FL_NORMAL_POSITIONER, 292, 90, 116, 90, "");
	fl_set_positioner_xbounds(obj, 0, 1);
	fl_set_positioner_ybounds(obj, 0, 1);
	fl_set_object_callback(obj, animation_template_form_x_y_positioner_cb, 0);
//	xval = fl_add_box(FL_DOWN_BOX,270,40,100,30,"");
//	yval = fl_add_box(FL_DOWN_BOX,270,90,100,30,"");
//	fl_set_object_color(xval,FL_COL1,FL_COL1);
//	fl_set_object_color(yval,FL_COL1,FL_COL1);

// position x y display
fdui -> animation_template_form_x_y_position_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 415, 90, 60, 15, "");
//	fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
	fl_set_object_lsize(obj, FL_SMALL_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

// espace
fdui -> animation_template_form_espace_slider = obj =\
	fl_add_valslider(FL_HOR_NICE_SLIDER, 130, 90, 110, 30, "extra character spacing");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_espace_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, -20.0, 80.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_espace_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 240, 95, 20, 20, "one");
	fl_set_object_callback(obj, animation_template_form_espace_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

// despace
fdui -> animation_template_form_despace_slider = obj =\
	fl_add_valslider(FL_HOR_NICE_SLIDER, 130, 130, 110, 30, "despace\nexplode");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_despace_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, -10.0, 10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_despace_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 240, 135, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_despace_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

// contrast
fdui -> animation_template_form_contrast_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 500, 100, 30, 110, "contr.");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_contrast_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 100.0, 0.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

// dcontrast
fdui -> animation_template_form_dcontrast_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 500, 222, 30, 110, "dcontr.\nfade");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dcontrast_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dcontrast_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 505, 350, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dcontrast_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

// transparency
fdui -> animation_template_form_transparency_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 550, 100, 30, 110, "transp.");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_transparency_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 100.0, 0.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

// dtransparency
fdui -> animation_template_form_dtransparency_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 550, 222, 30, 110, "dtransp.\ndissolve");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dtransparency_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dtransparency_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 555, 350, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dtransparency_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

// color circle
fdui -> animation_template_form_color_circle_dial = obj =\
	fl_add_dial(FL_LINE_DIAL, 585, 110, 60, 60, "color");
	fl_set_object_callback(obj, animation_template_form_color_circle_dial_cb, 0);
	fl_set_dial_return(obj, FL_RETURN_CHANGED);
	fl_set_dial_bounds(obj, 0, 360);
	fl_set_dial_cross(obj, 1);
	fl_set_dial_direction(obj, FL_DIAL_CCW);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
//	fl_set_dial_step(obj, float step);
	
// color degrees out only
fdui -> animation_template_form_color_degrees_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 600, 190, 40, 25, "");
//    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_NORMAL_STYLE);
	fl_set_object_lsize(obj, FL_SMALL_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

// dcolor
fdui -> animation_template_form_dcolor_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 600, 222, 30, 110, "dcolor\ncolor change");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dcolor_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dcolor_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 605, 350, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dcolor_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

//saturation
fdui -> animation_template_form_saturation_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 650, 100, 30, 110, "sat.");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_saturation_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 100.0, 0.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

//dsaturation
fdui -> animation_template_form_dsaturation_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 650, 222, 30, 110, "dsat.");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dsaturation_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dsaturation_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 655, 350, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dsaturation_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

fdui -> animation_template_form_heading_dial = obj =\
	fl_add_dial(FL_LINE_DIAL, 314, 214, 72, 72, "HEADING");
	fl_set_object_callback(obj, animation_template_form_heading_dial_cb, 0);
	fl_set_dial_return(obj, FL_RETURN_CHANGED);
	fl_set_dial_bounds(obj, 0, 360);
	fl_set_dial_cross(obj, 1);
	fl_set_dial_direction(obj, FL_DIAL_CCW);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
//	fl_set_dial_step(obj, float step);
	
fdui -> animation_template_form_heading_degrees_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 335, 190, 30, 20, "");
//	fl_set_object_boxtype(obj, FL_DOWN_BOX);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lcol(obj, FL_BLACK);
	fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> animation_template_form_dheading_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 335, 312, 30, 110, "dheading\ncircle");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dheading_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dheading_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 340, 440, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dheading_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

fdui -> animation_template_form_heading_or_x_y_select_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 425, 235, 50, 30, "Heading\nor X Y");
	fl_set_object_callback(obj, animation_template_form_heading_or_x_y_select_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> animation_template_form_xpos_slider = obj = \
	fl_add_valslider(FL_VERT_NICE_SLIDER, 275, 190, 30, 110, "xpos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_xpos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, -999.0, 999.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);
	fl_hide_object(obj);

fdui -> animation_template_form_dxpos_slider = obj = \
	fl_add_valslider(FL_VERT_NICE_SLIDER, 275, 312, 30, 110, "dxpos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dxpos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);
	fl_hide_object(obj);

fdui -> animation_template_form_dxpos_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 280, 440, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dxpos_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);
	fl_hide_object(obj);

fdui -> animation_template_form_ypos_slider = obj = \
	fl_add_valslider(FL_VERT_NICE_SLIDER, 335, 190, 30, 110, "ypos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_ypos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, -999.0, 999.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);
	fl_hide_object(obj);

fdui -> animation_template_form_dypos_slider = obj = \
	fl_add_valslider(FL_VERT_NICE_SLIDER, 335, 312, 30, 110, "dypos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dypos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);
	fl_hide_object(obj);

fdui -> animation_template_form_dypos_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 340, 440, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dypos_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);
	fl_hide_object(obj);

fdui -> animation_template_form_speed_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 275, 190, 30, 110, "speed");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_speed_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, 0.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dspeed_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 275, 312, 30, 110, "dspeed\nacceleration");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dspeed_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dspeed_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 280, 440, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dspeed_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

fdui -> animation_template_form_zpos_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 395, 190, 30, 110, "zpos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_zpos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 100.0, 0.0);
	fl_set_slider_precision(obj, 0);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dzpos_slider = obj =\
	fl_add_valslider(FL_VERT_NICE_SLIDER, 395, 312, 30, 110, "dzpos");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, animation_template_form_dzpos_slider_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	fl_set_slider_bounds(obj, 10.0, -10.0);
	fl_set_slider_precision(obj, 2);
	fl_set_object_boxtype(obj, FL_FLAT_BOX);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_BOTTOM);

fdui -> animation_template_form_dzpos_slider_reset_button = obj =\
	fl_add_round3dbutton(FL_NORMAL_BUTTON, 400, 440, 20, 20, "zero");
	fl_set_object_callback(obj, animation_template_form_dzpos_slider_reset_button_cb, 0);
	fl_set_object_color(obj, FL_BLUE, FL_WHITE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM | FL_ALIGN_CENTER);

fdui -> animation_template_form_vespace_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 455, 450, 50, 30, "vespace");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		animation_template_form_vespace_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_BOTTOM);

fdui -> animation_template_form_center_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 455, 400, 50, 30, "center");
	fl_set_object_callback(obj, animation_template_form_center_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> animation_template_form_reformat_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 515, 400, 50, 30, "reformat");
	fl_set_object_callback(obj, animation_template_form_reformat_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> animation_template_form_default_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 400, 90, 30, "DEFAULTS");
	fl_set_object_callback(obj, animation_template_form_default_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> animation_template_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 450, 90, 30, "CANCEL");
	fl_set_object_callback(obj, animation_template_form_cancel_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> animation_template_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 450, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, animation_template_form_accept_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

/*
fdui -> animation_template_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 400, 450, 20, 20, "-");
	fl_set_object_callback(obj, animation_template_form_fontsize_down_button_cb, 0);
*/

/*
fdui -> animation_template_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 430, 450, 20, 20, "+");
	fl_set_object_callback(obj, animation_template_form_fontsize_up_button_cb, 0);
*/

fl_end_form(); /* animation_template_form */


fdui -> subtitle_color_selector_form =\
fl_bgn_form(FL_UP_BOX, 305, 150);

fdui -> subtitle_color_selector_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 15, 3, 285, 30,\
	"S U B T I T L E  C O L O R  S E L E C T O R");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER | FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_NORMAL_SIZE);

fdui -> subtitle_color_selector_form_color0_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 15, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color1_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 50, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color2_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 85, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color3_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 120, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color4_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 155, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color5_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 190, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color6_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 225, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color7_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 260, 35, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color8_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 15, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color9_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 50, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color10_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 85, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color11_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 120, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color12_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 155, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color13_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 190, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color14_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 225, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_color15_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 260, 70, 30, 30, "");
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> subtitle_color_selector_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 200, 110, 90, 30, "CANCEL");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fl_end_form(); /* subtitle_color_selector_form */


fdui -> global_subtitle_palette_form =\
fl_bgn_form(FL_UP_BOX, 700, 250);

fdui -> global_subtitle_palette_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 5, 350, 30,\
	"G L O B A L  S U B T I T L E  P A L E T T E");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> global_subtitle_palette_form_color_slider_red = obj =\
	fl_add_valslider(FL_VERT_SLIDER, 555, 50, 25, 100, "RED");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, global_subtitle_palette_form_color_slider_red_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);
	fl_set_slider_bounds(obj, 255.0, 0.0);
	fl_set_slider_precision(obj, 0);

fdui -> global_subtitle_palette_form_color_slider_green = obj =\
	fl_add_valslider(FL_VERT_SLIDER, 590, 50, 25, 100, "GREEN");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);	
	fl_set_object_callback(obj, global_subtitle_palette_form_color_slider_green_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_slider_bounds(obj, 255.0, 0.0);
	fl_set_slider_precision(obj, 0);

fdui -> global_subtitle_palette_form_color_slider_blue = obj =\
	fl_add_valslider(FL_VERT_SLIDER, 625, 50, 25, 100, "BLUE");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, global_subtitle_palette_form_color_slider_blue_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);
	fl_set_slider_bounds(obj, 255.0, 0.0);
	fl_set_slider_precision(obj, 0);

fdui -> global_subtitle_palette_form_color_buttons_group =\
fl_bgn_group();

fdui -> global_subtitle_palette_form_color0_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 50, 50, 50, 50, "0");
	fl_set_object_callback(obj, global_subtitle_palette_form_color0_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color1_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 110, 50, 50, 50, "1");
	fl_set_object_callback(obj, global_subtitle_palette_form_color1_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color2_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 170, 50, 50, 50, "2");
	fl_set_object_callback(obj, global_subtitle_palette_form_color2_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color3_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 230, 50, 50, 50, "3");
	fl_set_object_callback(obj, global_subtitle_palette_form_color3_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color4_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 290, 50, 50, 50, "4");
	fl_set_object_callback(obj, global_subtitle_palette_form_color4_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color5_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 350, 50, 50, 50, "5");
	fl_set_object_callback(obj, global_subtitle_palette_form_color5_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color6_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 410, 50, 50, 50, "6");
	fl_set_object_callback(obj, global_subtitle_palette_form_color6_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color7_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 470, 50, 50, 50, "7");
	fl_set_object_callback(obj, global_subtitle_palette_form_color7_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color8_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 50, 110, 50, 50, "8");
	fl_set_object_callback(obj, global_subtitle_palette_form_color8_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color9_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 110, 110, 50, 50, "9");
	fl_set_object_callback(obj, global_subtitle_palette_form_color9_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color10_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 170, 110, 50, 50, "10");
	fl_set_object_callback(obj, global_subtitle_palette_form_color10_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color11_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 230, 110, 50, 50, "11");
	fl_set_object_callback(obj, global_subtitle_palette_form_color11_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color12_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 290, 110, 50, 50, "12");
	fl_set_object_callback(obj, global_subtitle_palette_form_color12_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color13_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 350, 110, 50, 50, "13");
	fl_set_object_callback(obj, global_subtitle_palette_form_color13_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color14_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 410, 110, 50, 50, "14");
	fl_set_object_callback(obj, global_subtitle_palette_form_color14_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);

fdui -> global_subtitle_palette_form_color15_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 470, 110, 50, 50, "15");
	fl_set_object_callback(obj, global_subtitle_palette_form_color15_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
fl_end_group();

fdui -> global_subtitle_palette_form_defaults_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 240, 170, 90, 30, "DEFAULTS");
	fl_set_object_callback(obj, global_subtitle_palette_form_defaults_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> global_subtitle_palette_form_color_circle_dial = obj =\
	fl_add_dial(FL_LINE_DIAL, 430, 170, 60, 60, "COLOR CIRCLE");
	fl_set_object_callback(obj, global_subtitle_palette_form_color_circle_dial_cb, 0);
	fl_set_dial_return(obj, FL_RETURN_CHANGED);
	fl_set_dial_bounds(obj, 0, 360);
	fl_set_dial_cross(obj, 1);
	fl_set_dial_direction(obj, FL_DIAL_CCW);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
//	fl_set_dial_step(obj, float step);
	
fdui -> global_subtitle_palette_form_color_circle_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 500, 190, 50, 20, "");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, global_subtitle_palette_form_color_circle_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 6);
	fl_deactivate_object(obj);

fdui -> global_subtitle_palette_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 200, 90, 30, "CANCEL");
	fl_set_object_callback(obj, global_subtitle_palette_form_cancel_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> global_subtitle_palette_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 200, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, global_subtitle_palette_form_accept_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

/*
fdui -> global_subtitle_palette_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 400, 200, 20, 20, "-");
	fl_set_object_callback(obj, global_subtitle_palette_form_fontsize_down_button_cb, 0);
*/

/*
fdui -> global_subtitle_palette_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 430, 200, 20, 20, "+");
	fl_set_object_callback(obj, global_subtitle_palette_form_fontsize_up_button_cb, 0);
*/

fl_end_form(); /* global_subtitle_palette_form */


fdui -> text_properties_form =\
fl_bgn_form(FL_UP_BOX, 550, 400);

fdui -> text_properties_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 5, 350, 30,\
	"T E X T  P R O P E R T I E S");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> text_properties_form_fontname_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 50, 90, 30, "FONT NAME");
	fl_set_object_callback(obj, text_properties_form_fontname_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> text_properties_form_fontname_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 120, 50, 410, 25, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> text_properties_form_fontname_output_field_text = obj =\
	fl_add_box(FL_NO_BOX, 120, 80, 410, 25, "font");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> text_properties_form_fontsize_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 90, 50, 30, "fontsize");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);                           
	fl_set_object_callback(obj, text_properties_form_fontsize_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);                  
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);   
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE); 	
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_iso_extension_number_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 130, 50, 30, "iso extension");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);                           
	fl_set_object_callback(obj, text_properties_form_iso_extension_number_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);                  
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);   
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE); 	
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_espace_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 210, 130, 50, 30, "extra character\nhorizontal space");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);                           
	fl_set_object_callback(obj, text_properties_form_espace_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);                  
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);   
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE); 	
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_vespace_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 210, 170, 50, 30, "extra character\nvertical space");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);                           
	fl_set_object_callback(obj, text_properties_form_vespace_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);                  
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);   
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE); 	
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_dvd_default_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 100, 90, 30, "SOME\nDEFAULTS");
	fl_set_object_callback(obj, text_properties_form_dvd_default_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> text_properties_form_outline_thickness_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 170, 50, 30, "outline thickness");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_outline_thickness_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	
fdui -> text_properties_form_blur_radius_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 210, 50, 30, "blur radius");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_blur_radius_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_center_text_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 210, 210, 90, 30, "CENTER\nTEXT");
	fl_set_object_callback(obj, text_properties_form_center_text_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> text_properties_form_no_kerning_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 310, 210, 90, 30, "NO KERNING");
	fl_set_object_callback(obj, text_properties_form_no_kerning_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_hide_object(obj);

fdui -> text_properties_form_anti_alias_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 410, 210, 90, 30, "ANTI ALIAS");
	fl_set_object_callback(obj, text_properties_form_anti_alias_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> text_properties_form_color0_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 250, 90, 30, "BACKGROUND\nCOLOR");
	fl_set_object_callback(obj, text_properties_form_color0_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_DARKER_COL1);

fdui -> text_properties_form_color1_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 150, 250, 90, 30, "BODY\nCOLOR");
	fl_set_object_callback(obj, text_properties_form_color1_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_DARKER_COL1);

fdui -> text_properties_form_color2_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 280, 250, 90, 30, "OUTLINE1\nCOLOR");
	fl_set_object_callback(obj, text_properties_form_color2_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_DARKER_COL1);

fdui -> text_properties_form_color3_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 410, 250, 90, 30, "OUTLINE2\nCOLOR");
	fl_set_object_callback(obj, text_properties_form_color3_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_DARKER_COL1);

fdui -> text_properties_form_contrast0_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 300, 50, 30, "backgrnd\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_contrast0_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_contrast1_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 300, 50, 30, "body\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_contrast1_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_contrast2_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 280, 300, 50, 30, "outline1\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_contrast2_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_contrast3_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 410, 300, 50, 30, "outline2\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		text_properties_form_contrast3_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> text_properties_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 300, 350, 20, 20, "-");
	fl_set_object_callback(obj, text_properties_form_fontsize_down_button_cb, 0);
	fl_hide_object(obj);

fdui -> text_properties_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 330, 350, 20, 20, "+");
	fl_set_object_callback(obj, text_properties_form_fontsize_up_button_cb, 0);
	fl_hide_object(obj);

fdui -> text_properties_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 350, 90, 30, "CANCEL");
	fl_set_object_callback(obj, text_properties_form_cancel_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	
fdui -> text_properties_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 350, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, text_properties_form_accept_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

fl_end_form(); /* text_properties_form */


fdui -> ebu_general_subtitle_information_form =\
fl_bgn_form(FL_UP_BOX, 700, 500);

fdui -> ebu_general_subtitle_information_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 5, 350, 30,\
	"E B U  G E N E R A L  S U B T I T L E  I N F O R M A T I O N");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

/* Byte 0-2 Code Page Number CPN */
fdui -> ebu_general_subtitle_information_form_code_page_number_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 125, 40, 32, 20, "Code Page Number");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_code_page_number_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 3);

/* Byte 3-10 Disc Format Code DFC */
fdui -> ebu_general_subtitle_information_form_disk_format_code_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 260, 40, 64, 20, "Disk Format Code");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_disk_format_code_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 8);
	fl_deactivate_object(obj);

fdui -> ebu_general_subtitle_information_form_standard_code_buttons_group =\
fl_bgn_group();

/* Byte 11 Display Standard Code */
// 3 buttons, open subtitling, level 1 teletext, level 2 teletext
fdui -> ebu_general_subtitle_information_form_display_standard_code_open_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 340, 40, 90, 20, "OPEN SUBS");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_standard_code_open_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext1_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 440, 40, 90, 20, "LEVEL1 TXT");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_standard_code_teletext1_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> ebu_general_subtitle_information_form_display_standard_code_teletext2_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 540, 40, 90, 20, "LEVEL2 TXT");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_standard_code_teletext2_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
fl_end_group();

/* Byte 12-13 Character Code Table number CCT */
// Latin 0x30 0x30
// Latin /Cyrillic  0x30 0x31
// Latin/Arabic     0x30 x032
// Latin/Greek      0x30 0x33
// Latin/Hebrew     0x30 0x34
fdui -> ebu_general_subtitle_information_form_character_code_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 125, 65, 32, 20, "Character Code");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_character_code_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 2);
	fl_deactivate_object(obj);

/* Byte 14-15 Language Code LC */
// Dutch, English, Spanish, French, Italian, German, Greek, Hebrew.
fdui -> ebu_general_subtitle_information_form_language_code_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 260, 65, 32, 20, "Language Code");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_language_code_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 2);

/* Byte 251-252 Maximum Number of Displayable Characters in any text row MNC */
// 0-99 decimal
fdui -> ebu_general_subtitle_information_form_max_columns_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 410, 65, 32, 20, "Max columns");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_max_columns_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 2);

/* Byte 253-254 Maximum Number of Displayable Rows MNR */
// 0-99 decimal
fdui -> ebu_general_subtitle_information_form_max_rows_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 510, 65, 32, 20, "Max rows");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_max_rows_title_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 2);

/* Byte 16-47 Original Program Title OPT */
fdui -> ebu_general_subtitle_information_form_original_program_title_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 90, 256, 20, "Original Program Title");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_original_program_title_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 48-79 Original Episode Title OET */
fdui -> ebu_general_subtitle_information_form_original_episode_title_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 115, 256, 20, "Original Episode Title");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_original_episode_title_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 80-111 Translated Program Title TPT */
fdui -> ebu_general_subtitle_information_form_translated_program_title_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 140, 256, 20, "Translated Program Title");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_translated_program_title_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 112-143 Translated Episode Title TET */
fdui -> ebu_general_subtitle_information_form_translated_episode_title_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 165, 256, 20, "Translated Episode Title");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_translated_episode_title_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 144-175 Tranlators Name TN */
fdui -> ebu_general_subtitle_information_form_original_translators_name_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 190, 256, 20, "Translators Name");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_translators_name_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* button defaults Dutch */
fdui -> ebu_general_subtitle_information_form_defaults_dutch_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 550, 190, 120, 20, "DEFAULTS DUTCH");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_defaults_dutch_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

/* Byte 176-207 Translators Contact Details TCD */
fdui -> ebu_general_subtitle_information_form_translators_contact_details_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 215, 256, 20, "Translators Contact Details");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_translators_contact_details_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 277-308 Publisher PUB */
fdui -> ebu_general_subtitle_information_form_publisher_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 240, 256, 20, "Publisher");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_publisher_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 309-340 Editors Name EN */
fdui -> ebu_general_subtitle_information_form_editors_name_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 265, 256, 20, "Editors Name");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_editors_name_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 341-372 Editor's Contact Details ECD */
fdui -> ebu_general_subtitle_information_form_editors_contact_details_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 290, 256, 20, "Editors Contact");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_editors_contact_details_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 32);

/* Byte 208-223 Subtitle List Reference code SLR */
// 16 character string as reference for subtitle list
fdui -> ebu_general_subtitle_information_form_subtitle_list_reference_code_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 315, 128, 20, "Subtitle List Reference");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_subtitle_list_reference_code_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 16);

/* Byte 224-229 Creation Date CD */
// ISO8601 YYMMDD
fdui -> ebu_general_subtitle_information_form_creation_date_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 340, 58, 20, "Creation Date");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_creation_date_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 6);

/* Byte 230-235 Revision Date RD */
// ISO8601 YYMMDD
fdui -> ebu_general_subtitle_information_form_revision_date_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 290, 340, 58, 20, "Revision Date");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_revision_date_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 6);
	fl_deactivate_object(obj);

/* Byte 236-237 Revision Number RN */
// 0-99 decimal
fdui -> ebu_general_subtitle_information_form_revision_number_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 460, 340, 32, 20, "Revision Number");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_revision_number_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 2);

/* Byte 238-242 Total Number of Text and Timing Information (TTI) blocks TNB */
// 0-9 99 99 decimal
fdui -> ebu_general_subtitle_information_form_tti_blocks_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 200, 365, 64, 20, "Number Text and Timing Info blocks");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_tti_blocks_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 5);
	fl_deactivate_object(obj);

/* Byte 243-247 Total Number of Subtitles TNS */
// 0-9 99 99 decimal
fdui -> ebu_general_subtitle_information_form_number_of_subtitles_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 340, 365, 64, 20, "Number subs");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_number_of_subtitles_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 5);
	fl_deactivate_object(obj);

/* Byte 248-250 Total  Number of Subtitle Groups TNG */
// 0-255
fdui -> ebu_general_subtitle_information_form_subtitle_groups_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 510, 365, 32, 20, "Number Sub Groups");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_subtitle_groups_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 3);
	fl_deactivate_object(obj);

/* Byte 256-263 Time Code: Start Of Program TCP */
// hhmmssff
fdui -> ebu_general_subtitle_information_form_timecode_start_of_program_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 390, 88, 20, "Timecode: Prog Start");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_timecode_start_of_program_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 8);

/* Byte 264-271 Time Code: First In-Cue TCF*/
// hhmmssff
fdui -> ebu_general_subtitle_information_form_timecode_first_cue_in_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 375, 390, 88, 20, "Timecode: First In-Cue");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_timecode_first_cue_in_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 8);
	fl_deactivate_object(obj);

/* Byte 255 Time Code: Status TCS */
// 0x30 Not intended for use (TCP and TCF in GSI block; and TCI TCO in TTI blocks)
// 0x31 Intended for use
//1 button 'time code valid'
fdui -> ebu_general_subtitle_information_form_timecode_valid_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 490, 390, 100, 20, "TIMECODE VALID");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_timecode_valid_button_cb, 0);
	fl_set_object_color(obj, FL_DARKORANGE, FL_GREEN);

/* Byte 272 Total Number of Disks TND */
// <= 9
fdui -> ebu_general_subtitle_information_form_number_of_disks_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 415, 32, 20, "Total disks");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_number_of_disks_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 1);
	fl_deactivate_object(obj);

/* Byte 273 Disk Sequence Number DSN */
// 1-9
fdui -> ebu_general_subtitle_information_form_disk_sequence_number_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 275, 415, 32, 20, "Disk Sequence");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_disk_sequence_number_input_cb, 0);
	fl_set_object_color(obj, FL_YELLOW, FL_YELLOW);
	fl_set_input_maxchars(obj, 1);
	fl_deactivate_object(obj);

/* Byte 274-276 Country of Origin CO */
// NLD
fdui -> ebu_general_subtitle_information_form_country_of_origin_input = obj =\
	fl_add_input(FL_NORMAL_INPUT, 400, 415, 64, 20, "Country Origin");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_country_of_origin_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_input_maxchars(obj, 3);

fdui -> ebu_general_subtitle_information_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 450, 90, 30, "CANCEL");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_cancel_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> ebu_general_subtitle_information_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 450, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_accept_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

/*
fdui -> ebu_general_subtitle_information_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 400, 450, 20, 20, "-");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_fontsize_down_button_cb, 0);
*/

/*
fdui -> ebu_general_subtitle_information_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 430, 450, 20, 20, "+");
	fl_set_object_callback(obj, ebu_general_subtitle_information_form_fontsize_up_button_cb, 0);
*/

fl_end_form(); /* ebu_general_subtitle_information_form */


fdui -> subtitle_font_form =\
fl_bgn_form(FL_UP_BOX, 550, 400);

fdui -> subtitle_font_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 5, 350, 30,\
	"D E F A U L T  S U B T I T L E  F O N T  S E T T I N G S");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> subtitle_font_form_fontname_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 50, 90, 30, "DEFAULT\nFONTNAME");
	fl_set_object_callback(obj, subtitle_font_form_fontname_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> subtitle_font_form_fontname_output_field = obj =\
	fl_add_text(FL_NORMAL_TEXT, 120, 50, 410, 25, "");
    fl_set_object_boxtype(obj,FL_DOWN_BOX);
    fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
    fl_set_object_lcol(obj, FL_BLACK);
    fl_set_object_color(obj, FL_SPRINGGREEN, FL_COL1);

fdui -> subtitle_font_form_fontname_output_field_text = obj =\
	fl_add_box(FL_NO_BOX, 120, 80, 410, 25, "font");
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_CENTER);

fdui -> subtitle_font_form_dvd_default_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 100, 90, 30, "DVD\nDEFAULTS");
	fl_set_object_callback(obj, subtitle_font_form_dvd_default_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> subtitle_font_form_cvd_default_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 150, 90, 30, "CVD\nDEFAULTS");
	fl_set_object_callback(obj, subtitle_font_form_cvd_default_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> subtitle_font_form_svcd_default_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 340, 150, 90, 30, "SVCD\nDEFAULTS");
	fl_set_object_callback(obj, subtitle_font_form_svcd_default_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> subtitle_font_form_no_kerning_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 310, 200, 90, 30, "NO KERNING");
	fl_set_object_callback(obj, subtitle_font_form_no_kerning_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_hide_object(obj);

fdui -> subtitle_font_form_anti_alias_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 410, 200, 90, 30, "ANTI ALIAS");
	fl_set_object_callback(obj, subtitle_font_form_anti_alias_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> subtitle_font_form_character_point_size_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 100, 35, 30, "point\nsize");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, subtitle_font_form_character_point_size_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> subtitle_font_form_character_style_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 100, 30, 30, "ISO\nextension");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, subtitle_font_form_character_style_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> subtitle_font_form_outline_thickness_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 150, 50, 30, "outline\nthickness");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_outline_thickness_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	
fdui -> subtitle_font_form_blur_radius_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 150, 50, 30, "blur\nradius");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_outline_blur_radius_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_espace_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 200, 50, 30, "extra char\nhor space");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_espace_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_vespace_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 280, 200, 50, 30, "extra char\nvert space");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_vespace_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_center_text_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 20, 200, 90, 30, "CENTER\nTEXT");
	fl_set_object_callback(obj, subtitle_font_form_center_text_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> subtitle_font_form_color0_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 250, 90, 30, "BACKGROUND\nCOLOR");
	fl_set_object_callback(obj, subtitle_font_form_color0_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_COL1);

fdui -> subtitle_font_form_color1_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 150, 250, 90, 30, "BODY\nCOLOR");
	fl_set_object_callback(obj, subtitle_font_form_color1_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_COL1);

fdui -> subtitle_font_form_color2_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 280, 250, 90, 30, "OUTLINE1\nCOLOR");
	fl_set_object_callback(obj, subtitle_font_form_color2_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_COL1);

fdui -> subtitle_font_form_color3_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 410, 250, 90, 30, "OUTLINE2\nCOLOR");
	fl_set_object_callback(obj, subtitle_font_form_color3_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_lcolor(obj, FL_COL1);

fdui -> subtitle_font_form_contrast0_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 20, 300, 50, 30, "backgrnd\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_contrast0_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_contrast1_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 150, 300, 50, 30, "pattern\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_contrast1_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_contrast2_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 280, 300, 50, 30, "outline1\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_contrast2_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_contrast3_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 410, 300, 50, 30, "outline2\ncontrast");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj,\
		subtitle_font_form_contrast3_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);

fdui -> subtitle_font_form_subtitle_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 300, 350, 20, 20, "-");
	fl_set_object_callback(obj, subtitle_font_form_subtitle_fontsize_down_button_cb, 0);
	fl_hide_object(obj);

fdui -> subtitle_font_form_subtitle_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 330, 350, 20, 20, "+");
	fl_set_object_callback(obj, subtitle_font_form_subtitle_fontsize_up_button_cb, 0);
	fl_hide_object(obj);

fdui -> subtitle_font_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 350, 90, 30, "CANCEL");
	fl_set_object_callback(obj, subtitle_font_form_cancel_button_cb, 0);
//	fl_hide_object(obj);
	
fdui -> subtitle_font_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 350, 90, 30, "ACCEPT");
	fl_set_object_callback(obj, subtitle_font_form_accept_button_cb, 0);
	
fl_end_form(); /* subtitle_font_form */


fdui -> special_characters_form =\
fl_bgn_form(FL_UP_BOX, 220, 220);

/*
fdui -> special_characters_form_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 250, 5, 200, 30,\
	"S P E C I A L  C H A R A C T E R S");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
*/

fdui -> special_characters_form_input = obj =\
    /* only used as output */
	fl_add_input(FL_MULTILINE_INPUT, 5, 5, 210, 180, "");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, special_characters_form_input_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

fdui -> special_characters_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 10, 190, 60, 20, "CLOSE");
	fl_set_object_callback(obj, special_characters_form_cancel_button_cb, 0);

fdui -> special_characters_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 160, 190, 20, 20, "-");
	fl_set_object_callback(obj, special_characters_form_fontsize_down_button_cb, 0);

fdui -> special_characters_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 190, 190, 20, 20, "+");
	fl_set_object_callback(obj, special_characters_form_fontsize_up_button_cb, 0);

fl_end_form(); /* special_characters_form */


fdui -> fonts_form =\
fl_bgn_form(FL_UP_BOX, 550, 450);

fdui -> fonts_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 150, 5, 250, 30,\
	"F O N T  B R O W S E R");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> fonts_form_font_button_group =\
fl_bgn_group();

fdui -> fonts_form_global_fonts_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 50, 90, 30, "GLOBAL");
	fl_set_object_callback(obj, fonts_form_global_fonts_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> fonts_form_article_fonts_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 120, 50, 90, 30, "ARTICLES");
	fl_set_object_callback(obj, fonts_form_article_fonts_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> fonts_form_default_fonts_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 220, 50, 90, 30, "DEFAULT");
	fl_set_object_callback(obj, fonts_form_default_fonts_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fl_end_group();

fdui -> fonts_form_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 20, 100, 510, 300, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, fonts_form_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, fonts_form_browser_double_cb, 0);
//	fl_set_object_dblbuffer(obj, 1);

fdui -> fonts_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 300, 410, 20, 20, "-");
	fl_set_object_callback(obj, fonts_form_fontsize_down_button_cb, 0);

fdui -> fonts_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 330, 410, 20, 20, "+");
	fl_set_object_callback(obj, fonts_form_fontsize_up_button_cb, 0);

fdui -> fonts_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 440, 410, 90, 30, "CLOSE");
	fl_set_object_callback(obj, fonts_form_accept_button_cb, 0);
	
fl_end_form(); /* fonts_form */


fdui -> project_form =\
fl_bgn_form(FL_UP_BOX, 700, 500);

fdui -> project_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 5, 350, 30,\
	"P R O J E C T  B R O W S E R");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);

fdui -> project_form_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 20, 100, 560, 300, "");
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, project_form_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, project_form_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);

fdui -> project_form_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 160, 400, 420, 30, "New Project name");
	fl_set_input_return(obj, FL_RETURN_ALWAYS);
	fl_set_object_callback(obj, project_form_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> project_form_delete_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 290, 90, 30, "DELETE");
	fl_set_object_callback(obj, project_form_delete_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> project_form_add_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 400, 90, 30, "ADD");
	fl_set_object_callback(obj, project_form_add_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

/*
fdui -> project_form_cancel_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 450, 90, 30, "CANCEL");
	fl_set_object_callback(obj, project_form_cancel_button_cb, 0);
*/

fdui -> project_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 450, 90, 30, "CLOSE");
	fl_set_object_callback(obj, project_form_accept_button_cb, 0);
	
fdui -> project_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 400, 450, 20, 20, "-");
	fl_set_object_callback(obj, project_form_fontsize_down_button_cb, 0);

fdui -> project_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 430, 450, 20, 20, "+");
	fl_set_object_callback(obj, project_form_fontsize_up_button_cb, 0);

fl_end_form(); /* project_form */


fdui -> export_form =\
fl_bgn_form(FL_UP_BOX, 700, 500);

fdui -> export_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 175, 5, 350, 30,\
	"E X P O R T  S E T T I N G S");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);

fdui -> export_form_output_format_select_box = obj =\
	fl_add_box(FL_EMBOSSED_BOX, 10, 40, 310, 450, "");

fdui -> export_form_ppml_yuv_output_options_box = obj =\
	 fl_add_box(FL_BORDER_BOX, 18, 48, 194, 34, "");

fdui -> export_form_ppml_output_options_box = obj =\
	 fl_add_box(FL_BORDER_BOX, 18, 88, 294, 34, "");

fdui -> export_form_microdvdplayer_output_options_box = obj =\
	 fl_add_box(FL_BORDER_BOX, 18, 328, 194, 34, "");

fdui -> export_form_ebu_stl_output_options_box = obj =\
	 fl_add_box(FL_BORDER_BOX, 18, 408, 194, 34, "");

fdui -> export_form_select_text = obj =\
	fl_add_text(FL_NORMAL_TEXT, 75, 20, 140, 25, "Output format");
	fl_set_object_lalign(obj,FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);

fdui -> export_form_output_format_selection_group =\
fl_bgn_group();

fdui -> export_form_enable_ppml_for_subtitler_yuv_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 50, 90, 30, "PPML for\nsubtitler-YUV");
	fl_set_object_callback(obj, export_form_enable_ppml_for_subtitler_yuv_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	
fdui -> export_form_enable_ppml_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 90, 90, 30, "PPM for\ntranscode");
	fl_set_object_callback(obj, export_form_enable_ppml_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	
fdui -> export_form_enable_suti_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 130, 90, 30, "SUTI");
	fl_set_object_callback(obj, export_form_enable_suti_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_ssa_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 170, 90, 30, "SSA");
	fl_set_object_callback(obj, export_form_enable_ssa_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_vplayer_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 210, 90, 30, "VPLAYER");
	fl_set_object_callback(obj, export_form_enable_vplayer_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_submux_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 250, 90, 30, "Submux");
	fl_set_object_callback(obj, export_form_enable_submux_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_submux_dvd_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 290, 90, 30, "Submux DVD");
	fl_set_object_callback(obj, export_form_enable_submux_dvd_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_microdvdplayer_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 330, 90, 30, "Micro dvd\nplayer");
	fl_set_object_callback(obj, export_form_enable_microdvdplayer_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_iauthor_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 370, 90, 30, "I-Author\nOGT editor");
	fl_set_object_callback(obj, export_form_enable_iauthor_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
//	fl_hide_object(obj);

fdui -> export_form_enable_ebu_stl_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 410, 90, 30, "EBU .STL");
	fl_set_object_callback(obj, export_form_enable_ebu_stl_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_enable_srt_output_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 20, 450, 90, 30, "SRT");
	fl_set_object_callback(obj, export_form_enable_srt_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
fl_end_group();

fdui -> export_form_enable_chapter_list_output_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 590, 250, 90, 30, "Chapter list");
	fl_set_object_callback(obj, export_form_enable_chapter_list_output_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_use_animation_templates_button = obj =\
	fl_add_button(FL_RADIO_BUTTON, 120, 50, 90, 30, "Use animation\ntemplates");
	fl_set_object_callback(obj, export_form_use_animation_templates_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	
fdui -> export_form_ppml_use_dvd_colors_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 120, 90, 90, 30, "USE\nDVD COLORS");
	fl_set_object_callback(obj, export_form_ppml_use_dvd_colors_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_ppml_enable_monitor_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 220, 90, 90, 30, "USE\nMONITOR");
	fl_set_object_callback(obj, export_form_ppml_enable_monitor_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> export_form_let_microdvdplayer_format_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 120, 330, 90, 30, "LET PLAYER\nFORMAT");
	fl_set_object_callback(obj, export_form_let_microdvdplayer_format_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> export_form_ebu_general_subtitle_information_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 120, 410, 90, 30, "SETTINGS");
	fl_set_object_callback(obj, export_form_ebu_general_subtitle_information_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> export_form_accept_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 590, 450, 90, 30, "CLOSE");
	fl_set_object_callback(obj, export_form_accept_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_COL1);
	
fdui -> export_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 400, 450, 20, 20, "-");
	fl_set_object_callback(obj, export_form_fontsize_down_button_cb, 0);
	fl_hide_object(obj);

fdui -> export_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 430, 450, 20, 20, "+");
	fl_set_object_callback(obj, export_form_fontsize_up_button_cb, 0);
	fl_hide_object(obj);

fl_end_form(); /* export_form */

fdui -> main_form =\
	fl_bgn_form(FL_NO_BOX, 790, 570);
	obj = fl_add_box(FL_UP_BOX, 0, 0, 790, 570,"");
	fl_set_object_lsize(obj,FL_HUGE_SIZE);
	fl_set_object_lstyle(obj,FL_FIXEDBOLDITALIC_STYLE + FL_EMBOSSED_STYLE);

fdui -> main_form_title = obj =\
	fl_add_text(FL_NORMAL_TEXT, 100, 5, 500, 30,\
	"P A N T E L T J E (c)  S U B T I T L E  E D I T O R");
	fl_set_object_lalign(obj, FL_ALIGN_CENTER|FL_ALIGN_INSIDE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj,FL_NORMAL_SIZE);

fdui -> main_form_h_size_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 50, 40, 45, 30, "hor\nsize");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_h_size_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_h_margin_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 160, 40, 45, 30, "hor\nmargin");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_h_margin_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_h_factor_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 260, 40, 50, 30, "h\nfactor");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_h_factor_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_v_size_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 350, 40, 45, 30, "vert\nsize");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_v_size_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_v_margin_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 460, 40, 45, 30, "vert\nmargin");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_v_margin_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_v_factor_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 560, 40, 50, 30, "v\nfactor");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_v_factor_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_object_lalign(obj, FL_ALIGN_RIGHT);
	fl_set_input(obj, "-1");

fdui -> main_form_preview_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 690, 6, 80, 24, "PRE VIEW");
	fl_set_object_callback(obj, main_form_preview_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_video_in_preview_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 690, 36, 80, 24, "VIDEO");
	fl_set_object_callback(obj, main_form_video_in_preview_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_browser = obj =\
	fl_add_browser(FL_HOLD_BROWSER, 20, 120, 650, 270, "");/* was 100, 560 */
	fl_set_object_color(obj, FL_WHITE, 15);
	fl_set_object_callback(obj, main_form_browser_cb, 0);
	fl_set_browser_dblclick_callback(obj, main_form_browser_double_cb, 0);
	fl_set_object_dblbuffer(obj, 1);
	fl_set_browser_fontsize(obj, FL_MEDIUM_SIZE); 

fdui -> main_form_search_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 260, 80, 200, 30, "Search\nwords");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_search_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_audio_mode_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 20, 80, 90, 30, "AUDIO RAW");
	fl_set_object_callback(obj, main_form_audio_mode_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_show_time_overlap_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 130, 80, 70, 30, "show time\noverlap");
	fl_set_object_callback(obj, main_form_show_time_overlap_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_search_case_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 470, 80, 90, 30, "CASE SENS");
	fl_set_object_callback(obj, main_form_search_case_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_search_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 570, 80, 90, 30, "SEARCH");
	fl_set_object_callback(obj, main_form_search_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_text_hold_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 240, 450, 40, 30, "TEXT\nHOLD");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_text_hold_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
//	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_text_duration_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 330, 450, 30, 30, "Global\nlength");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_text_duration_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_input(obj, "7");
	
fdui -> main_form_frames_per_second_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 250, 490, 60, 30, "Frames/\nsecond");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_frames_per_second_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	fl_set_input(obj, "-1");

fdui -> main_form_set_PAL_fps_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 320, 490, 35, 14, "PAL");
	fl_set_object_callback(obj, main_form_set_PAL_fps_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_set_NTSC_fps_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 320, 505, 35, 14, "NTSC");
	fl_set_object_callback(obj, main_form_set_NTSC_fps_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_frame_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 410, 450, 90, 30, "Frame");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_frame_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_frame_now_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 410, 490, 90, 30, "UPDATE");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_frame_now_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
//	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
//	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_current_frame_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 680, 490, 90, 30, "Now");
//	fl_add_input(FL_NORMAL_INPUT, 710, 490, 60, 30, "Now");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_current_frame_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
	
fdui -> main_form_play_part_button_frwd = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 510, 450, 40, 30, "@<<");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW); 
	fl_set_object_callback(obj, main_form_play_part_cb, -5);
//	fl_set_button_shortcut(obj, "1", 0);

fdui -> main_form_play_part_button_rwd = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 550, 450, 40, 30, "@<");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_color(obj, FL_COL1, FL_BLUE); 
	fl_set_object_callback(obj, main_form_play_part_cb, -1);
//	fl_set_button_shortcut(obj, "2", 0);

fdui -> main_form_play_part_button_fwd = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 590, 450, 40, 30, "@>");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_color(obj, FL_COL1, FL_GREEN); 
	fl_set_object_callback(obj, main_form_play_part_cb, 1);
//	fl_set_button_shortcut(obj, "3", 0);

fdui -> main_form_play_part_button_ffwd = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 630, 450, 40, 30, "@>>");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);	
	fl_set_object_callback(obj, main_form_play_part_cb, 5);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW); 
//	fl_set_button_shortcut(obj, "4", 0);

fdui -> main_form_mem1_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 690, 530, 70, 30, "MEM");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);	
	fl_set_object_callback(obj, main_form_mem1_button_cb, 5);
	fl_set_object_color(obj, FL_COL1, FL_RED); 
//	fl_set_button_shortcut(obj, "4", 0);

fdui -> main_form_preview_snapshot_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 495, 530, 60, 30, "preview\nsnapshot");
//	fl_set_object_boxtype(obj, FL_FRAME_BOX);	
	fl_set_object_callback(obj, main_form_preview_snapshot_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN); 
//	fl_set_button_shortcut(obj, "4", 0);

fdui -> main_form_rcl_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 520, 490, 70, 30, "RCL");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);	
	fl_set_object_callback(obj, main_form_rcl_button_cb, 5);
	fl_set_object_color(obj, FL_COL1, FL_GREEN); 
//	fl_set_button_shortcut(obj, "4", 0);

fdui -> main_form_snap_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 590, 490, 40, 30, "SNAP");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);	
	fl_set_object_callback(obj, main_form_snap_button_cb, 5);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW); 
//	fl_set_button_shortcut(obj, "4", 0);

fdui -> main_form_video_display_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 680, 40, 90, 30, "PICTURE");
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, main_form_video_display_button_cb, 0);
	fl_hide_object(obj);

fdui -> main_form_next_red_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 80, 90, 30, "NEXT TOO LONG");
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, main_form_next_red_button_cb, 0);

fdui -> main_form_volume_slider = obj =\
	fl_add_slider(FL_HOR_FILL_SLIDER, 680, 120, 90, 30, "VOLUME");
	fl_set_slider_return(obj, FL_RETURN_CHANGED);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);
	fl_set_object_callback(obj, main_form_volume_slider_cb, 0);

fdui -> main_form_erase_all_empty_lines_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 160, 90, 30, "ERASE ALL\nEMPTY LINES");
	fl_set_object_callback(obj, main_form_erase_all_empty_lines_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);
//	fl_set_object_lstyle(obj, FL_BOLD_STYLE);
	fl_set_object_lsize(obj, FL_TINY_SIZE);

fdui -> main_form_edit_frame_list_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 200, 90, 30, "EDIT FRAME LIST");
	fl_set_object_callback(obj, main_form_edit_frame_list_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);

fdui -> main_form_spellcheck_input_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 680, 240, 90, 30, "SPELL CHECK");
	fl_set_object_callback(obj, main_form_spellcheck_input_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_BLUE);

fdui -> main_form_delete_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 300, 90, 30, "DELETE");
	fl_set_object_callback(obj, main_form_delete_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_RED);

fdui -> main_form_clear_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 360, 90, 30, "CLEAR");
	fl_set_object_callback(obj, main_form_clear_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_add_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 680, 400, 90, 30, "ADD");
	fl_set_object_callback(obj, main_form_add_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_GREEN);

fdui -> main_form_play_button = obj =\
	fl_add_button(FL_TOUCH_BUTTON, 680, 450, 90, 30, "PLAY");
	fl_set_object_callback(obj, main_form_play_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_text_input_field = obj =\
	fl_add_input(FL_NORMAL_INPUT, 60, 400, 610, 30, "Text");
	fl_set_input_return(obj, FL_RETURN_CHANGED);
	fl_set_object_callback(obj, main_form_text_input_field_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_WHITE);

	/*
	if you set this to character style used, it would need to be 720 width
	Using a smaller char style allows you to view more text.
	*/
	fl_set_object_lstyle(obj, FL_BOLD_STYLE); //used_character_style in cb
	fl_set_object_lsize(obj, FL_MEDIUM_SIZE);
//	fl_set_button_shortcut(obj, "^N", 0);	

fdui -> main_form_hold_text_properties_button = obj =\
	fl_add_button(FL_PUSH_BUTTON, 290, 433, 110, 14, "default font");
	fl_set_object_callback(obj, main_form_hold_text_properties_button_cb, 0);
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);

fdui -> main_form_fontsize_up_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 580, 530, 20, 20, "-");
	fl_set_object_callback(obj, main_form_fontsize_down_button_cb, 0);

fdui -> main_form_fontsize_down_button = obj =\
	fl_add_button(FL_NORMAL_BUTTON, 610, 530, 20, 20, "+");
	fl_set_object_callback(obj, main_form_fontsize_up_button_cb, 0);

fdui -> main_form_outfield =\
//	obj = fl_add_text(FL_NORMAL_TEXT, 20, 530, 520, 20, "");
//	obj = fl_add_text(FL_NORMAL_TEXT, 20, 530, 540, 20, "");
	obj = fl_add_text(FL_NORMAL_TEXT, 20, 530, 335, 20, "");
	fl_set_object_boxtype(obj,FL_DOWN_BOX);
	fl_set_object_lstyle(obj,FL_BOLD_STYLE);
	fl_set_object_lcol(obj, FL_BLUE);
	fl_set_object_color(obj, FL_YELLOW, FL_COL1);
           
fdui -> main_form_synthesize_switch =\
	obj = fl_add_button(FL_PUSH_BUTTON, 110, 433, 80, 14, "synthesize off");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, main_form_synthesize_switch_cb, 0);

fdui -> main_form_output_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 110, 450, 80, 30, "OUTPUT");
	fl_set_object_color(obj, FL_COL1, FL_YELLOW);
	fl_set_object_callback(obj, main_form_output_switch_cb, 0);

fdui -> main_form_move_from_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 200, 450, 30, 30, "M V");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, main_form_move_from_switch_cb, 0);

fdui -> main_form_align_start_button =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 110, 490, 30, 30, "A S");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, main_form_align_start_button_cb, 0);

fdui -> main_form_align_end_button =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 160, 490, 30, 30, "A E");
	fl_set_object_color(obj, FL_COL1, FL_DARKORANGE);
	fl_set_object_callback(obj, main_form_align_end_button_cb, 0);

fdui -> main_form_auto_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 20, 450, 80, 30, "AUTO");
	fl_set_object_color(obj, FL_COL1, FL_RED);
	fl_set_object_callback(obj, main_form_auto_switch_cb, 0);

fdui -> main_form_exit_switch =\
	obj = fl_add_button(FL_NORMAL_BUTTON, 20, 490, 80, 30, "EXIT");
	fl_set_object_color(obj, FL_COL1, FL_WHITE);
	fl_set_object_callback(obj, main_form_exit_switch_cb, 0);

fdui -> main_form_file_menu = obj =\
	fl_add_menu(FL_PULLDOWN_MENU, 20, 10, 90, 20, "FILE");
	fl_set_object_boxtype(obj, FL_FRAME_BOX);
	fl_set_object_callback(obj, main_form_file_menu_cb, 0);
	fl_set_menu(obj,\
"PROJECTS|\
IMPORT PPML FILE|\
IMPORT SUTI FILE|\
IMPORT SSA FILE|\
IMPORT NANDUB FILE|\
IMPORT SRT FILE|\
EXPORT SETTINGS|\
ANIMATION TEMPLATES|\
XSTE FONTS|\
GLOBAL SUBTITLE PALETTE|\
DEFAULT SUBTITLE FONT SETTINGS|\
FORCE DEFAULT TO ALL SUBTITLES|\
SPECIAL CHARACTERS|\
EXIT");

/* Note: any data aquisition functions can be called from this callback */
/*
fl_add_signal_callback(\
	SIGALRM, (FL_SIGNAL_HANDLER)print_new_york_time, &mydata);
alarm(1);
*/

/*
fdui -> io_callback =\
	obj = fl_add_io_callback(fileno(filefd), FL_READ, io_cb, void *data)
*/

fl_end_form(); /* main form */

return fdui;
}/* end function FD_xste *create_form_main_form */

