#ifndef _ANIMATION_TEMPLATE_H_
#define _ANIMATION_TEMPLATE_H_

struct animation_template
	{
	char *name;/* this is the animation_template space period */
	int status;
	int browser_line;
	char *fontname;
	int fontsize;
	int iso;
	double outline;
	double blur;
	font_desc_t *pfd;

	double xpos;
	double dxpos;
	double pxpos;

	double ypos;
	double dypos;
	double pypos;

	double zpos;
	double dzpos;
	double pzpos;

	double espace;
    double despace;
	double pespace;

	double vespace;	

	double color;
	double dcolor;
	double pcolor;

	double saturation;
	double dsaturation;
	double psaturation;

	double contrast;
	double dcontrast;
	double pcontrast;

	double transparency;
	double dtransparency;
	double ptransparency;

	double heading;
	double dheading;
	double pheading;
	double pdheading;

	double speed;
	double dspeed;
	double pspeed;
	double pdspeed;

	char *ptext;

	struct animation_template *nxtentr;
	struct animation_template *prventr;
	};
struct animation_template *animation_templatetab[2]; /* first element points to first entry,
			second element to last entry */


#endif /* _ANIMATION_TEMPLATE_H_ */

