/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/


#include "xste.h"

extern FD_xste *fdui;
extern FD_xste *fd_export_form;


static int ebu_general_subtitle_information_form_modified_flag;
static int fontsizes_modified_flag;


void ebu_general_subtitle_information_form_code_page_number_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->code_page_number, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_code_page_number_input_cb */


void ebu_general_subtitle_information_form_disk_format_code_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi -> disk_format_code, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_disk_format_code_input_cb */


void ebu_general_subtitle_information_form_standard_code_open_button_cb(FL_OBJECT *ob, long data)
{
strcpy(pebu_gsi ->display_standard_code, "0");

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_standard_code_open_button_cb */


void ebu_general_subtitle_information_form_standard_code_teletext1_button_cb(FL_OBJECT *ob, long data)
{
strcpy(pebu_gsi ->display_standard_code, "1");

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_standard_code_teletext1_button_cb */


void ebu_general_subtitle_information_form_standard_code_teletext2_button_cb(FL_OBJECT *ob, long data)
{

strcpy(pebu_gsi ->display_standard_code, "2");

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_standard_code_teletext2_button_cb */


void ebu_general_subtitle_information_form_character_code_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->character_code_table_number, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_character_code_input_cb */


void ebu_general_subtitle_information_form_language_code_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->language_code, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_language_code_input_cb */


void ebu_general_subtitle_information_form_original_program_title_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->original_program_title, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_original_program_title_input_cb */


void ebu_general_subtitle_information_form_original_episode_title_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->original_episode_title, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_original_episode_title_input_cb */


void ebu_general_subtitle_information_form_translated_program_title_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->translated_program_title, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_translated_program_title_input_cb */


void ebu_general_subtitle_information_form_translated_episode_title_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->translated_episode_title, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_translated_episode_title_input_cb */


void ebu_general_subtitle_information_form_translators_name_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->translators_name, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_translators_name_input_cb */


void ebu_general_subtitle_information_form_translators_contact_details_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->translators_contact_details, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_translators_contact_details_input_cb */


void ebu_general_subtitle_information_form_subtitle_list_reference_code_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->subtitle_list_reference_code, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_subtitle_list_reference_code_input_cb */


void ebu_general_subtitle_information_form_creation_date_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->creation_date, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_creation_date_input_cb */


void ebu_general_subtitle_information_form_revision_date_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->revision_date, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_revision_date_input_cb */


void ebu_general_subtitle_information_form_revision_number_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->revision_number, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_revision_number_input_cb */


void ebu_general_subtitle_information_form_tti_blocks_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->total_number_of_text_and_timing_information, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_tti_blocks_input_cb */


void ebu_general_subtitle_information_form_number_of_subtitles_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->number_of_subtitles, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_number_of_subtitles_input_cb */


void ebu_general_subtitle_information_form_subtitle_groups_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->total_number_of_subtitle_groups, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_subtitle_groups_input_cb */


void ebu_general_subtitle_information_form_max_columns_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->maximum_displayable_characters_in_any_text_row, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_max_columns_input_cb */


void ebu_general_subtitle_information_form_max_rows_title_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->maximum_number_of_displayable_rows, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_max_rows_title_input_cb */


void ebu_general_subtitle_information_form_timecode_valid_button_cb(FL_OBJECT *ob, long data)
{
int a;

a = fl_get_button(ob);

if(a) strcpy(pebu_gsi ->timecode_status, "1");
else strcpy(pebu_gsi ->timecode_status, "0");

set_timecode_valid_button();

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_timecode_valid_button_cb */


void ebu_general_subtitle_information_form_timecode_start_of_program_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->timecode_start_of_program, ptr);

/* recalculate the timing */
if(! xste_frames_to_ebu_gsi_tti() ) return;

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_timecode_start_of_program_input_cb */


void ebu_general_subtitle_information_form_timecode_first_cue_in_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->timecode_first_in_cue, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_timecode_first_cue_in_input_cb */


void ebu_general_subtitle_information_form_number_of_disks_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->total_number_of_disks, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_number_of_disks_input_cb */


void ebu_general_subtitle_information_form_disk_sequence_number_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->disk_sequence_number, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_disk_sequence_number_input_cb */


void ebu_general_subtitle_information_form_country_of_origin_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->country_of_origin, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_country_of_origin_input_cb */


void ebu_general_subtitle_information_form_publisher_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->publisher, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_publisher_input_cb */


void ebu_general_subtitle_information_form_editors_name_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->editors_name, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_editors_name_input_cb */


void ebu_general_subtitle_information_form_editors_contact_details_input_cb(FL_OBJECT *ob, long data)
{
char *ptr;

ptr = (char *)fl_get_input(ob);
if(! ptr) return;

strcpy(pebu_gsi ->editors_contact_details, ptr);

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_editors_contact_details_input_cb */


void ebu_general_subtitle_information_form_defaults_dutch_button_cb(FL_OBJECT *ob, long data)
{

if(! set_ebu_sti_defaults("dutch") ) return;

ebu_general_subtitle_information_form_modified_flag = 1;
} /* end function ebu_general_subtitle_information_form_defaults_dutch_button_cb */


void ebu_general_subtitle_information_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(ebu_general_subtitle_information_form_fontsize < 5) ebu_general_subtitle_information_form_fontsize++;
size = integer_to_fontsize(ebu_general_subtitle_information_form_fontsize);

//fl_set_object_lsize(fdui -> ebu_general_subtitle_information_form_input, size);

save_fontsizes();

} /* end function ebu_general_subtitle_information_form_fontsize_up_button_cb */


void ebu_general_subtitle_information_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;
if(ebu_general_subtitle_information_form_fontsize > 0) ebu_general_subtitle_information_form_fontsize--;
size = integer_to_fontsize(ebu_general_subtitle_information_form_fontsize);

//fl_set_object_lsize(fdui -> ebu_general_subtitle_information_form_input, size);

save_fontsizes();

} /* end function ebu_general_subtitle_information_form_fontsize_down_button_cb */


void ebu_general_subtitle_information_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
if( ebu_general_subtitle_information_form_modified_flag)
	{
	/* restore from disc */
	load_general_settings();
	load_project_vars();

	if(! load_ebu_gsi() ) return;

	ebu_general_subtitle_information_form_modified_flag = 0;
 	}

fl_hide_form(fdui -> ebu_general_subtitle_information_form);

/* restore from disc */
if(fontsizes_modified_flag)
	{
	load_fontsizes();
	fontsizes_modified_flag = 0;
	}

ebu_general_subtitle_information_form_shown_flag = 0;

} /* end function ebu_general_subtitle_information_form_cancel_button_cb */


void ebu_general_subtitle_information_form_accept_button_cb(FL_OBJECT *ob, long data)
{
if(ebu_general_subtitle_information_form_modified_flag)
	{
	if(! save_ebu_gsi() ) return;

	ebu_general_subtitle_information_form_modified_flag = 0;
	}

fl_hide_form(fdui -> ebu_general_subtitle_information_form);

if(fontsizes_modified_flag)
	{
	save_fontsizes();

	save_general_settings();
	save_project_vars();

	fontsizes_modified_flag = 0;
	}

ebu_general_subtitle_information_form_shown_flag = 0;
} /* end function ebu_general_subtitle_information_form_accept_button_cb */


