/*
This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "xste.h"

FD_xste *fdui;


int erase_special_characters_flag;
static int fontsizes_modified_flag;


void special_characters_form_input_cb(FL_OBJECT *ob, long data)
{
}/* end function special_characters_form_field_cb */


void special_characters_form_fontsize_up_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;

if(special_characters_form_fontsize < 5) special_characters_form_fontsize++;
size = integer_to_fontsize(special_characters_form_fontsize);

fl_set_object_lsize(fdui -> special_characters_form_input, size);
}/* end function special_characters_form_fontsize_up_button_cb */


void special_characters_form_fontsize_down_button_cb(FL_OBJECT *ob, long data)
{
int size;

fontsizes_modified_flag = 1;

if(special_characters_form_fontsize > 0) special_characters_form_fontsize--;
size = integer_to_fontsize(special_characters_form_fontsize);

fl_set_object_lsize(fdui -> special_characters_form_input, size);
}/* end function special_characters_form_fontsize_down_button_cb */


void special_characters_form_cancel_button_cb(FL_OBJECT *ob, long data)
{
fl_hide_form(fdui -> special_characters_form);

if(fontsizes_modified_flag) save_fontsizes();
}/* end function special_characters_form_cancel_button_cb */


